// ***********************************************************************************************************************
// ** File:         arp.h                                                                                               **
// ** Title:        Routine for ARP Protocol                                                                            **
// ** CPU:          ATMega644                                                                                           **
// ** Created:      28.02.2008                                                                                          **
// ** Revised:      28.02.2008                                                                                          **
// ** Version:      1.0                                                                                                 **
// ** Note:                                                                                                             **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// ***********************************************************************************************************************

// COMPILER INFORMATION **************************************************************************************************
#ifndef ARP_H                                                               //
#define ARP_H                                                               //
// ***********************************************************************************************************************

// INCLUDES **************************************************************************************************************
#include "enc28j60.h"                                                       //
#include "timer.h"                                                          //
#include "ethernet.h"                                                       //
//#include "debug.h"                                                          //
// ***********************************************************************************************************************

// DEFINES ***************************************************************************************************************
#define ARP_HEADER_LENGTH            28                                     // ARP Header ist 28 Bytes Lang 
#define ARP_ANSWER                   0                                      //
#define NO_ARP_ANSWER                !ARP_ANSWER                            //
// ***********************************************************************************************************************

// VARIABLES *************************************************************************************************************
extern unsigned char arptablebuffer [10];                                   // Einfache Arp Tabelle fr einen eintrag
// ***********************************************************************************************************************

// FUNCTIONS *************************************************************************************************************
void arp(void);                                                             //
unsigned char GetIP2MAC ( unsigned long IPadr );                            //
// ***********************************************************************************************************************

// ARP Struct ************************************************************************************************************
struct ARP_header                                                           //
{                                                                           //
    unsigned int HWtype;                                                    // 2 Byte
    unsigned int Protocoltype;                                              // 2 Byte
    unsigned char HWsize;                                                   // 1 Byte
    unsigned char Protocolsize;                                             // 1 Byte
    unsigned int ARP_Opcode;                                                // 2 Byte
    unsigned char ARP_sourceMac[6];                                         // 6 Byte
    unsigned long ARP_sourceIP;                                             // 4 Byte
    unsigned char ARP_destMac[6];                                           // 6 Byte
    unsigned long ARP_destIP;                                               // 4 Byte = 28 Bytes
};                                                                          // 
// ***********************************************************************************************************************

// ARP Tabelle Struct ****************************************************************************************************
struct ARP_TABLE                                                            //
{                                                                           //
    unsigned long ARP_IP;                                                   // 4 Byte
    unsigned char ARP_MAC[6];                                               // 6 Byte
};                                                                          //
// ***********************************************************************************************************************
#endif
