// ***********************************************************************************************************************
// ** File:         ethernet.c                                                                                          **
// ** Title:        Routine for ETH II Protocol                                                                         **
// ** CPU:          ATMega644                                                                                           **
// ** Created:      28.02.2008                                                                                          **
// ** Revised:      28.02.2008                                                                                          **
// ** Version:      1.0                                                                                                 **
// ** Note:                                                                                                             **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// ***********************************************************************************************************************

// INCLUDES **************************************************************************************************************
#include "ethernet.h"                                                       //
// ***********************************************************************************************************************

// DEFINES ***************************************************************************************************************
                                                                            //
// ***********************************************************************************************************************

// VARIABLES *************************************************************************************************************
union LONG_BYTE MyIP;                                                       // Die eigene IP Adresse
union LONG_BYTE Netmask;                                                    // Die eigene SubnetMask
union LONG_BYTE Gateway;                                                    // Die Gateway Adresse
union LONG_BYTE DNSserver;                                                  // Die DNS Server Adresse
// ***********************************************************************************************************************

// ETH II Header umbauen *************************************************************************************************
void MakeETHheader( unsigned char * MACadress )                             //
{                                                                           //
    unsigned int i;                                                         //
    struct ETH_header *ETH_packet;                                          // ETH_struct anlegen
    ETH_packet = (struct ETH_header *)buffer;                               //
    ETH_packet->ETH_typefield = 0x0008;                                     // Type auf IP 0800 setzen
    for ( i = 0 ; i < 6 ; i++ )                                             //
    {                                                                       //
        ETH_packet->ETH_destMac[i] = MACadress[i];                          // Die empangene Mac Adresse als Ziel einsetzen
        ETH_packet->ETH_sourceMac[i] = MyMac[i];                            // Meine Mac als Absender einsetzen
    }                                                                       //
    return;                                                                 //
}                                                                           //
// ***********************************************************************************************************************

// berprft ob ein Paket angekommen ist *********************************************************************************
void ethernet(void)                                                         //
{                                                                           //
    unsigned int packet_lenght;                                             // Variable fr die Lnge des empfangenen Pakets
    struct ETH_header *ETH_packet;                                          // Der Struct ETH_header ist der Vaiable ETH_Packet zugeordnet und zeigt auf buffer
    ETH_packet = (struct ETH_header *)buffer;                               //
    packet_lenght = enc28j60PacketReceive(MAX_FRAMELEN,buffer);             // Nachschauen ob ein Paket angekommen ist
    if (packet_lenght)                                                      // Wenn packet_lenght > 0 ist dann ist ein gltiges Paket da
    {                                                                       //
        switch ( ETH_packet->ETH_typefield )                                // welcher type ist gesetzt 
        {                                                                   //
            case 0x0608:                                                    // Wenn arp dann
                arp();                                                      // sprung zur ARP Routine
            break;                                                          //
            case 0x0008:                                                    // Wenn ip dann
                ip( packet_lenght );                                        // sprung zur IP Routine
            break;                                                          //
        }                                                                   //
    }                                                                       //
    return;                                                                 //
}                                                                           //
// ***********************************************************************************************************************
