// ***********************************************************************************************************************
// ** File:         ethernet.h                                                                                          **
// ** Title:        Routine for ETH II Protocol                                                                         **
// ** CPU:          ATMega644                                                                                           **
// ** Created:      28.02.2008                                                                                          **
// ** Revised:      28.02.2008                                                                                          **
// ** Version:      1.0                                                                                                 **
// ** Note:                                                                                                             **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// ***********************************************************************************************************************

// COMPILER INFORMATION **************************************************************************************************
#ifndef ETHERNET_H                                                          //
#define ETHERNET_H                                                          //
// ***********************************************************************************************************************

// INCLUDES **************************************************************************************************************
#include "arp.h"                                                            //
#include "ip.h"                                                             //
#include "enc28j60.h"                                                       //
#include "global.h"
//#include "debug.h"                                                          //
// ***********************************************************************************************************************

// DEFINES ***************************************************************************************************************
#define ETHERNET_HEADER_LENGTH          14                                  // Ethernet Header ist 14 Bit lang
// ***********************************************************************************************************************

// VARIABLES *************************************************************************************************************
extern union LONG_BYTE MyIP;                                                // Die eigene IP Adresse
extern union LONG_BYTE Netmask;                                             // Die eigene SubnetMask
extern union LONG_BYTE Gateway;                                             // Die Gateway Adresse
extern union LONG_BYTE DNSserver;                                           // Die DNS Server Adresse
// ***********************************************************************************************************************

// Verzgerungsschleife **************************************************************************************************
void MakeETHheader( unsigned char * MACadress );                            //
void ethernet(void);                                                        //
// ***********************************************************************************************************************

// ETH Struct ************************************************************************************************************
struct ETH_header                                                           // 
{                                                                           // 
    unsigned char ETH_destMac[6];                                           // 6 Byte
    unsigned char ETH_sourceMac[6];                                         // 6 Byte
    unsigned int ETH_typefield;                                             // 2 Byte = 14 Bytes
};                                                                          // 
// ***********************************************************************************************************************
#endif
