// ***********************************************************************************************************************
// ** File:         global.h                                                                                            **
// ** Title:                                                                                                            **
// ** CPU:          ATMega644                                                                                           **
// ** Created:      27.02.2008                                                                                          **
// ** Revised:      27.02.2008                                                                                          **
// ** Version:      1.0                                                                                                 **
// ** Note:                                                                                                             **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// ***********************************************************************************************************************

// COMPILER INFORMATION **************************************************************************************************
#ifndef GLOBAL_H                                                            //
#define GLOBAL_H                                                            //

#ifndef F_CPU                                                               //
#define F_CPU 8000000UL                                                     // Interner RC Oszillator Frequenz = 8 MHz
#endif                                                                      //
// ***********************************************************************************************************************

// INCLUDES **************************************************************************************************************
#include <stdint.h>                                                         // ISO C99 Integer types
#include <avr/io.h>                                                         // ATTINY I/O's
//#include "dhcp.h"
// ***********************************************************************************************************************

// STRUCTURES ************************************************************************************************************
struct bits                                                                 // Define I/O's, AVR I/O's sind nicht BITadressierbar!
{                                                                           //
    uint8_t b0:1;                                                           //
    uint8_t b1:1;                                                           //
    uint8_t b2:1;                                                           //
    uint8_t b3:1;                                                           //
    uint8_t b4:1;                                                           //
    uint8_t b5:1;                                                           //
    uint8_t b6:1;                                                           //
    uint8_t b7:1;                                                           //
}   __attribute__((__packed__));                                            //
// ***********************************************************************************************************************

// DHCP union ************************************************************************************************************
union LONG_BYTE                                                             //
{                                                                           //
    unsigned char BYTE[4];                                                  //
    unsigned long LONG;                                                     //
};                                                                          //
// ***********************************************************************************************************************

// DEFINES ***************************************************************************************************************
#define SBIT(port,pin) ((*(volatile struct bits*)&port).b##pin)             // I/O Defines vereinfachen

#define ENC28J60_DDR        DDRB                                            // 
#define ENC28J60_SCK        SBIT (PORTB,7)                                  // ENC Clk Pin
#define ENC28J60_MISO       SBIT (PINB,6)                                   // ENC SO Pin
#define ENC28J60_MOSI       SBIT (PORTB,5)                                  // ENC SI Pin
#define ENC28J60_CS         SBIT (PORTB,4)                                  // ENC CS Pin

#define LED SBIT (PORTD, 0)                                                 // 
// ***********************************************************************************************************************
#endif
