// ***********************************************************************************************************************
// ** File:         http.c                                                                                              **
// ** Title:        Routine for HTTP Protocol                                                                           **
// ** CPU:          AT89C51ED2                                                                                          **
// ** Created:      23.04.2007                                                                                          **
// ** Revised:      23.04.2007                                                                                          **
// ** Version:      1.0                                                                                                 **
// ** Note:                                                                                                             **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// ***********************************************************************************************************************

// INCLUDES **************************************************************************************************************
#include "http.h"                                                           //
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
// ***********************************************************************************************************************

// DEFINES ***************************************************************************************************************
                                                                            //
// ***********************************************************************************************************************

// VARIABLES *************************************************************************************************************
                                                                            //
// ***********************************************************************************************************************
/*
// HTTP Ausgabe String ***************************************************************************************************
unsigned int http_data_out (const char *http_string, unsigned int seq_no)   // rckgabewert = grsse des letzten Paketes
{                                                                           //
    unsigned char *http_buffer;                                             //
    unsigned int new_length = 0, zgr = 0, fzgr = 0;                         //
    http_buffer = &buffer[58];                                              // HTTP Buffer fngt ab Pos 58 an
                                                                            //
    //while (*http_string)                                                    //
    while ( pgm_read_byte ( &http_string [fzgr] ) )                         //
    {                                                                       //
        http_buffer = &buffer [ 58 + zgr ];                                 // http Buffer zeigt auf Pos 58 + zgr
        // *http_buffer = *http_string++;                                      // Byte aus dem String auslesen und an die Pos im http Buffer kopieren
        // *http_buffer = pgm_read_byte(&http_string[fzgr]);
        *http_buffer= pgm_read_byte ( &http_string [fzgr] );

        zgr++;                                                              // zgr inc
        fzgr++;
        if(zgr > 1450)                                                      // wenn Paket voll
        {                                                                   //
            new_length = zgr;                                               // neue lnge = zgr -1
            send_tcp_data (new_length, seq_no);                             // Daten senden neue lnge , alte lnge = Sequenznummer
            seq_no = new_length;                                            // aktuelle lnge wird alte lnge fr Sequenznummer
            zgr = 0;                                                        // zgr auf 0
        }                                                                   //
    }                                                                       //
    new_length = zgr;                                                       // neue lnge = zgr -1
    send_tcp_data (new_length, seq_no);                                     // Daten senden neue lnge , alte lnge = Sequenznummer
    return new_length;                                                      //
}                                                                           //
// ***********************************************************************************************************************

// HTTP Ausgabe String ***************************************************************************************************
unsigned int http_data_out (const char *http_string, unsigned int seq_no)   // rckgabewert = grsse des letzten Paketes
{                                                                           //
    unsigned char *http_buffer;                                             //
    unsigned int new_length = 0, zgr = 0, fzgr = 0;                         //
    //http_buffer = &buffer[58];                                              // HTTP Buffer fngt ab Pos 58 an
                                                                            //
    //while (*http_string)                                                    //
    while ( pgm_read_byte ( &http_string[zgr] ) )                         //
    {                                                                       //
        http_buffer = &buffer [ 58 + zgr ];
        *http_buffer = pgm_read_byte ( &http_string[zgr] );
        zgr++;                                                              // zgr inc
    }                                                                       //
    new_length = zgr;                                                       // neue lnge = zgr -1
    send_tcp_data (new_length, seq_no);                                     // Daten senden neue lnge , alte lnge = Sequenznummer
    return new_length;                                                      //
}                                                                           //
// ***********************************************************************************************************************
*/
// HTTP Ausgabe String ***************************************************************************************************
unsigned int http_data_out (PGM_P pointer, unsigned int seq_no)   // rckgabewert = grsse des letzten Paketes
{                                                                           //
    unsigned char *http_buffer;                                             //
    unsigned int new_length = 0, zgr = 0;                                   //
    
    http_buffer = &buffer [ 58 + zgr ];
    
    
    while ( pgm_read_byte ( pointer + zgr ) )                         //
    {                                                                       //
        http_buffer[zgr] = pgm_read_byte ( pointer + zgr );
        zgr++;                                                              // zgr inc
    }                                                                       //
    
    new_length = zgr;                                                       // neue lnge = zgr -1
    send_tcp_data (new_length, seq_no);                                     // Daten senden neue lnge , alte lnge = Sequenznummer
    return new_length;                                                      //
}                                                                           //
// ***********************************************************************************************************************

/*
#include <avr/pgmspace.h>

const char foo[] PROGMEM = "Foo";
const char bar[] PROGMEM = "Bar";

PGM_P array[2] PROGMEM = {
    foo,
    bar
};

int main (void)
{
    char buf[32];
    PGM_P p;
    int i;

    memcpy_P(&p, &array[i], sizeof(PGM_P));
    strcpy_P(buf, p);
    return 0;
}

*/


/*
// HTTP io Seite Daten ausfiltern ****************************************************************************************
void http_io_data (unsigned char *datastart)                                //
{                                                                           //
    unsigned char *ptr_port = 0;                                            // Zeiger auf port im HTTP String
    unsigned char *ptr_lcd = 0;                                             // Zeiger auf lcd im HTTP String
    unsigned char *ptr_rs232 = 0;                                           // Zeiger auf rs232 im HTTP String
    unsigned int zgr = 0;                                                   //
    ptr_port = strstr(datastart,"port=")+5;                                 // PORT im HTTP String suchen
    ptr_lcd = strstr(datastart,"lcd=")+4;                                   // LCD im HTTP String suchen
    ptr_rs232 = strstr(datastart,"rs232=")+6;                               // RS232 im HTTP String suchen
    while (datastart[zgr] != 0x20)                                          // Wenn "SPACE" dann ist der string zuende
    {                                                                       //
        if(datastart[zgr] == 0x26)                                          // Wenn "&" zeichen dann kommt die nchste Info
        {                                                                   //
            datastart[zgr] = 0x00;                                          // Teilstring durch 0 abschliessen
        }                                                                   //
        zgr++;                                                              // Pointer inkrementieren
    }                                                                       //
    datastart[zgr] = 0x00;                                                  // Letztes zeichen mit NULL abschliessen
    //P0 = 0xff - (atoi(ptr_port));                                           //
    //ausgabe = lcd;                                                          // Ausgabe ber Serielle Schnittstelle
    #ifdef _BERND                                                           //
    LCDCtrlOut(LCD_1_LINE);                                                 // Cursor auf 3. Zeile setzen
    printf_fast ("%s",ptr_lcd);                                             // LCD Text ausgeben
    #endif                                                                  //
    #ifdef _FRANK                                                           //
    Lcd_Setadress(3, 3);
    //LCDCtrlOut(LCD_2_LINE);                                                 // Cursor auf 3. Zeile setzen
    printf ("%s",ptr_lcd);                                                  // LCD Text ausgeben
    #endif                                                                  //
//    ausgabe = uart;                                                         // Ausgabe ber Serielle Schnittstelle
//    printf_fast ("%s",ptr_rs232);                                           // LCD Text ausgeben
    #ifdef _DEBUG                                                           // DEBUG **************************************
    print_uart_clock();                                                     // Uhr ber Uart ausgeben
    printf_fast ("HTTP_IO_DATA->LCD: %s\r\n",ptr_lcd);                      // Debug ausgabe
    print_uart_clock();                                                     // Uhr ber Uart ausgeben
    printf_fast ("HTTP_IO_DATA->RS232: %s\r\n",ptr_rs232);                  // Debug ausgabe
    #endif                                                                  // DEBUG **************************************
    return;                                                                 //
}                                                                           //
// ***********************************************************************************************************************

// HTTP io.html Seite senden *********************************************************************************************
void http_io ()                                                             //
{                                                                           //
    unsigned char *http_buffer;                                             //
    unsigned int htmlheadlength = 0, temp_len, seq_no;                      //
    unsigned char *ioptr = 0;                                               //
    http_buffer = &buffer[58];                                              // HTTP Buffer fngt ab Pos 58 an
    ioptr = strstr(http_buffer,"io.html?");                                 //
    if (ioptr != 0)                                                         // Wenn IO Parameter kommen dann
    {                                                                       //
        http_io_data(ioptr);                                                // Parameter auswerten
    }                                                                       //
    send_tcp_get_ack ();                                                    // Sendet den ACK fr das Empfangene GET Kommando
    temp_len = http_data_out (HtmlKopf1, 0);                                // rckgabewert = grsse des letzten Paketes
    seq_no = http_data_out (HtmlIO1, temp_len);                             // rckgabewert = grsse des letzten Paketes
    send_tcp_fin (seq_no);                                                  // Sendet FIN mit der lnge des letzten Datenpaket
    return;                                                                 //
}                                                                           //
// ***********************************************************************************************************************

// HTTP Ascii IP in eine "richtige" IP wandeln ***************************************************************************
unsigned long http_asc_to_ip (unsigned char *ascip)                         // In http kommt die IP so an :
{                                                                           // 192.168.0.123/0
    union LONG_BYTE IPLong;                                                 // das muss in einen Long wert gewandelt werden
    unsigned char *ptr_ip[4], i = 0, zgr = 0;                               //
    IPLong.LONG = 0;                                                        // Ergebniss lschen
                                                                            //
    while (i < 4)                                                           // Wenn schleife 4 mal durchlaufen ist dann
    {                                                                       // ist die IP adresse komplett
        ptr_ip[i] = &ascip[zgr];                                            // Pointer zeigt auf den anfang des strings
        while (ascip[zgr] != 0x2e && ascip[zgr] != 0x00)                    // wenn kein . und nicht NULL dann
        {                                                                   //
            zgr++;                                                          // Hilfszeiger inc
        }                                                                   //
        ascip[zgr] = 0x00;                                                  // wenn . oder NULL dann ersetzen durch NULL um string abzuschliessen
        IPLong.BYTE[i] = atoi(ptr_ip[i]);                                   // Teilstring in 
        zgr++;                                                              // Hilfszeiger inc
        i++;                                                                // Schleifenzhler inc
    }                                                                       //
    return IPLong.LONG;                                                     // IP als Long wert zurckgeben
}                                                                           //
// ***********************************************************************************************************************

// HTTP setup Seite senden ***********************************************************************************************
void http_setup_data (unsigned char *datastart)                             //
{                                                                           //
    unsigned char *ptr_ip = 0;                                              // Zeiger auf IP Adresse im HTTP String
    unsigned char *ptr_sub = 0;                                             // Zeiger auf Subnet Mask im HTTP String
    unsigned char *ptr_gate = 0;                                            // Zeiger auf Gateway Adresse im HTTP String
    unsigned char *ptr_dns = 0;                                             // Zeiger auf DNS Server Adresse im HTTP String
    unsigned char *ptr_tp = 0;                                              // Zeiger auf Timeserver Adresse im HTTP String
    unsigned int zgr = 0;                                                   //
    ptr_ip = strstr(datastart,"ip=")+3;                                     // IP Adresse im HTTP String suchen
    ptr_sub = strstr(datastart,"sub=")+4;                                   // Subnet Mask im HTTP String suchen
    ptr_gate = strstr(datastart,"gate=")+5;                                 // Gateway Adresse im HTTP String suchen
    ptr_dns = strstr(datastart,"dns=")+4;                                   // DNS Server Adresse im HTTP String suchen
    ptr_tp = strstr(datastart,"sntp=")+5;                                   // Timeserver Adresse im HTTP String suchen
    while (datastart[zgr] != 0x20)                                          // Wenn "SPACE" dann ist der string zuende
    {                                                                       //
        if(datastart[zgr] == 0x26)                                          // Wenn "&" zeichen dann kommt die nchste Info
        {                                                                   //
            datastart[zgr] = 0x00;                                          // Teilstring durch 0 abschliessen
        }                                                                   //
        zgr++;                                                              // Pointer inkrementieren
    }                                                                       //
    datastart[zgr] = 0x00;                                                  // Letztes zeichen mit NULL abschliessen
    MyIP.LONG = http_asc_to_ip (ptr_ip);                                    // Neue IP aus dem HTTP String lesen
    Netmask.LONG = http_asc_to_ip (ptr_sub);                                // Neue Subnet Mask aus dem HTTP String lesen
    Gateway.LONG = http_asc_to_ip (ptr_gate);                               // Neue Gateway Adresse aus dem HTTP String lesen
    DNSserver.LONG = http_asc_to_ip (ptr_dns);                              // Neue DNS Server Adresse aus dem HTTP String lesen
    //EEProm_Write_Long (MyIP.BYTE,EE_IP_Adr);                                // Schreibt die IP Adresse in das EEProm
    //EEProm_Write_Long (Netmask.BYTE,EE_Sub_Adr);                            // Schreibt die Subnet Mask in das EEProm
    //EEProm_Write_Long (Gateway.BYTE,EE_Gw_Adr);                             // Schreibt die Gateway Adresse in das EEProm
    //EEProm_Write_Long (DNSserver.BYTE,EE_DNS_Adr);                          // Schreibt die DNS Server Adresse in das EEProm
    //EEProm_Write (ptr_tp,strlen(ptr_tp)+1,EE_TP_Adr);                       // Schreibt die Timeserver Adresse in das EEProm
    #ifdef _DEBUG                                                           // DEBUG **************************************
    print_debug ("HTTP_SETUP_DATA->Data saved in EEProm \r\n");             //
    #endif                                                                  // DEBUG **************************************
    return;                                                                 //
}                                                                           //
// ***********************************************************************************************************************

// HTTP setup Seite senden ***********************************************************************************************
void http_mail_data(unsigned char *datastart)                               // Parameter auswerten
{                                                                           //
    unsigned char *ptr_smtp = 0;                                            // Zeiger auf SMTP Adresse im HTTP String
    unsigned char *ptr_mfrom = 0;                                           // Zeiger auf Kontoname im HTTP String
    unsigned char *ptr_msendto = 0;                                         // Zeiger auf Empfnger E-Mail Adresse im HTTP String
    unsigned char *ptr_msendn = 0;                                          // Zeiger auf Absender Name im HTTP String
    unsigned char *ptr_msubj = 0;                                           // Zeiger auf Subject im HTTP String
    unsigned char *ptr_mtext = 0;                                           // Zeiger auf Mailtext im HTTP String
    unsigned int zgr = 0;                                                   //
    ptr_smtp = strstr(datastart,"smtp=")+5;                                 // SMTP Adresse im HTTP String suchen
    ptr_mfrom = strstr(datastart,"mfrom=")+6;                               // Mail From im HTTP String suchen
    ptr_msendto = strstr(datastart,"msendto=")+8;                           // Mail RCPT To im HTTP String suchen
    ptr_msendn = strstr(datastart,"msendn=")+7;                             // Mail Sender Name im HTTP String suchen
    ptr_msubj = strstr(datastart,"msubj=")+6;                               // Mail Subject im HTTP String suchen
    ptr_mtext = strstr(datastart,"mtext=")+6;                               // Mail Text im HTTP String suchen
    while (datastart[zgr] != 0x20)                                          // Wenn "SPACE" dann ist der string zuende
    {                                                                       //
        if(datastart[zgr] == 0x26)                                          // Wenn "&" zeichen dann kommt die nchste Info
        {                                                                   //
            datastart[zgr] = 0x00;                                          // Teilstring durch 0 abschliessen
        }                                                                   //
        if(datastart[zgr] == 0x2b)                                          // Wenn "+" zeichen dann ersetzen durch
        {                                                                   //
            datastart[zgr] = 0x20;                                          // Space
        }                                                                   //
        zgr++;                                                              // Pointer inkrementieren
    }                                                                       //
    datastart[zgr] = 0x00;                                                  // Letztes zeichen mit NULL abschliessen
//    EEProm_Write (ptr_smtp,strlen(ptr_smtp)+1,EE_SMTP_Adr);                 // Schreibt die SMTP Adresse in das EEProm
//    EEProm_Write (ptr_mfrom,strlen(ptr_mfrom)+1,EE_Mfrom_Adr);              // Schreibt die Absender Email Adresse in das EEProm
//    EEProm_Write (ptr_msendto,strlen(ptr_msendto)+1,EE_Msendto_Adr);        // Schreibt die Empfnger Email Adresse in das EEProm
//    EEProm_Write (ptr_msendn,strlen(ptr_msendn)+1,EE_Msendn_Adr);           // Schreibt die Absender Name in das EEProm
//    EEProm_Write (ptr_msubj,strlen(ptr_msubj)+1,EE_Msubj_Adr);              // Schreibt den Betreff in das EEProm
//    EEProm_Write (ptr_mtext,strlen(ptr_mtext)+1,EE_MText_Adr);              // Schreibt den Text in das EEProm
    #ifdef _DEBUG                                                           // DEBUG **************************************
    print_debug ("HTTP_MAIL_DATA->Data saved in EEProm \r\n");              //
    #endif                                                                  // DEBUG **************************************
    return;                                                                 //
}                                                                           //
// ***********************************************************************************************************************

// HTTP setup Seite senden ***********************************************************************************************
void http_setup ()                                                          //
{                                                                           //
    unsigned char *http_buffer;                                             //
    unsigned int htmlheadlength = 0, temp_len, seq_no;                      //
    unsigned char *setupptr = 0;                                            //
    http_buffer = &buffer[58];                                              // HTTP Buffer fngt ab Pos 58 an
    setupptr = strstr(http_buffer,"setup.html?");                           //
    if (setupptr != 0)                                                      // Wenn Setup Parameter kommen dann
    {                                                                       //
        http_setup_data(setupptr);                                          // Parameter auswerten
    }                                                                       //
    send_tcp_get_ack ();                                                    // Sendet den ACK fr das Empfangene GET Kommando
    temp_len = http_data_out (HtmlKopf1, 0);                                // rckgabewert = grsse des letzten Paketes
    seq_no = http_data_out (HtmlSetup1, temp_len);                          // rckgabewert = grsse des letzten Paketes
    send_tcp_fin (seq_no);                                                  // Sendet FIN mit der lnge des letzten Datenpaket
    return;                                                                 //
}                                                                           //
// ***********************************************************************************************************************
*/

/*
// HTTP favicon.ico Seite senden *****************************************************************************************
void http_favicon ()                                                        //
{                                                                           //
    unsigned char *http_buffer;                                             //
    unsigned int htmlheadlength = 0;                                        //
    http_buffer = &buffer[58];                                              // HTTP Buffer fngt ab Pos 58 an
    send_tcp_get_ack ();                                                    // Sendet den ACK fr das Empfangene GET Kommando
                                                                            //
    strcpy(http_buffer,Favicon1);                                           // Favicon1 in den buffer kopieren
    htmlheadlength = strlen(http_buffer);                                   // Lnge von Favicon1 zwichenspeichern
    send_tcp_data (htmlheadlength, 0);                                      // Daten senden Sequenznummer nicht erhhen
                                                                            //
    memcpy(http_buffer,&Favicon2,sizeof(Favicon2));                         // Favicon2 in den buffer kopieren
    send_tcp_data (sizeof(Favicon2),htmlheadlength);                        // Daten senden Sequenznummer um die lnge von Favicon2 erhhen
                                                                            //
    send_tcp_fin (sizeof(Favicon2));                                        // Sendet FIN mit der lnge des letzten Datenpaket
    return;                                                                 //
}                                                                           //
// ***********************************************************************************************************************
*/

/*
// HTTP mail.html Seite senden *******************************************************************************************
void http_mail ()                                                           //
{                                                                           //
    unsigned char *http_buffer;                                             //
    unsigned int htmlheadlength = 0, temp_len, seq_no;                      //
    unsigned char *mailptr = 0;                                             //
    http_buffer = &buffer[58];                                              // HTTP Buffer fngt ab Pos 58 an
    mailptr = strstr(&buffer[58],"mail.html?");                             //
    if (mailptr != 0)                                                       // Wenn Setup Parameter kommen dann
    {                                                                       //
        http_mail_data(mailptr);                                            // Parameter auswerten
    }                                                                       //
    send_tcp_get_ack ();                                                    // Sendet den ACK fr das Empfangene GET Kommando
    temp_len = http_data_out (HtmlKopf1, 0);                                // rckgabewert = grsse des letzten Paketes
    seq_no = http_data_out (HtmlMail1, temp_len);                           // rckgabewert = grsse des letzten Paketes
    send_tcp_fin (seq_no);                                                  // Sendet FIN mit der lnge des letzten Datenpaket
    return;                                                                 //
}                                                                           //
// ***********************************************************************************************************************

// HTTP dyndata Seite senden *********************************************************************************************
void http_dyndata ()                                                        //
{                                                                           //
    unsigned char *http_buffer;                                             //
    http_buffer = &buffer[58];                                              // HTTP Buffer fngt ab Pos 58 an
    send_tcp_get_ack ();                                                    // Sendet den ACK fr das Empfangene GET Kommando
                                                                            //
    sprintf(http_buffer,"[\"0\",\"%02d:%02d:%02d\",\"%03d\",\"%03d\",\"%02d.%02d.%d\"]",// Systemzeit und zustand der Ports P0 und P1 in den Buffe kopieren
        hours,minutes,seconds,0xFF,0xFF,                          //
        day,month,year);                                                    //
                                                                            //
    send_tcp_data (strlen(http_buffer), 0);                                 // Daten senden Sequenznummer um die lnge von HtmlHead erhhen
    send_tcp_fin (strlen(http_buffer));                                     // Sendet FIN mit der lnge des letzten Datenpaket
    return;                                                                 //
}                                                                           //
// ***********************************************************************************************************************

// HTTP configIP Seite senden ********************************************************************************************
void http_configip ()                                                       //
{                                                                           //
    unsigned char *http_buffer;                                             //
    unsigned char tmpbuffer[48];                                            //
    http_buffer = &buffer[58];                                              // HTTP Buffer fngt ab Pos 58 an
    send_tcp_get_ack ();                                                    // Sendet den ACK fr das Empfangene GET Kommando
                                                                            //
    //EEProm_Read_String (tmpbuffer, EE_TP_Adr);                              // Time Server Adresse in den buffer kopieren
    sprintf(http_buffer,"[\"1\",\"%d.%d.%d.%d\",\"%d.%d.%d.%d\",",          // Ajax Index 1 und
        MyIP.BYTE[0],MyIP.BYTE[1],MyIP.BYTE[2],MyIP.BYTE[3],                // IP-Adresse und
        Netmask.BYTE[0],Netmask.BYTE[1],Netmask.BYTE[2],Netmask.BYTE[3]);   // Netmask in den buffer kopieren
                                                                            //
    sprintf(&http_buffer[strlen(http_buffer)],"\"%d.%d.%d.%d\",\"%d.%d.%d.%d\",",// Gateway Adresse und
        Gateway.BYTE[0],Gateway.BYTE[1],Gateway.BYTE[2],Gateway.BYTE[3],    // DNS Server adresse in den Buffer kopieren
        DNSserver.BYTE[0],DNSserver.BYTE[1],DNSserver.BYTE[2],DNSserver.BYTE[3]);//
                                                                            //
    sprintf(&http_buffer[strlen(http_buffer)],"\"%s\",\"%02x:%02x:%02x:%02x:%02x:%02x\"]",// Timeserver Adresse und
        tmpbuffer,                                                          // MacAdresse in den Buffer kopieren
        MyMac[0],MyMac[1],MyMac[2],MyMac[3],MyMac[4],MyMac[5]);             //
                                                                            //
    send_tcp_data (strlen(http_buffer), 0);                                 // Daten senden Sequenznummer nicht erhhen
    send_tcp_fin (strlen(http_buffer));                                     // Sendet FIN mit der lnge des letzten Datenpaket
    return;                                                                 //
}                                                                           //
// ***********************************************************************************************************************
*/

/*
// HTTP configMail Seite senden ******************************************************************************************
void http_configmail ()                                                     //
{                                                                           //
    unsigned int htmlheadlength = 0;                                        //
    unsigned char *http_buffer;                                             //
    http_buffer = &buffer[58];                                              // HTTP Buffer fngt ab Pos 58 an
    send_tcp_get_ack ();                                                    // Sendet den ACK fr das Empfangene GET Kommando
    http_buffer[0] = 0;                                                     // Http Buffer lschen
    //seqbuffer_write (http_buffer, AjaxKopf1);                             // HtmlKopf1 in den Buffer
    seqbuffer_write (http_buffer, "[\"2\",\"");                             // Index 2 fr Ajax funktion ausgeben
    EEProm_Read_String (&http_buffer[seqbufferptr], EE_SMTP_Adr);           // SMTP server aus  EEProm in buffer kopieren
    seqbuffer_write (http_buffer, "\",\"");                                 // 
    EEProm_Read_String (&http_buffer[seqbufferptr], EE_Mfrom_Adr);          // Mail From EEProm in buffer kopieren
    seqbuffer_write (http_buffer, "\",\"");                                 // 
    EEProm_Read_String (&http_buffer[seqbufferptr], EE_Msendto_Adr);        // RCPT To EEProm in buffer kopieren
    seqbuffer_write (http_buffer, "\",\"");                                 // 
    EEProm_Read_String (&http_buffer[seqbufferptr], EE_Msendn_Adr);         // Sender Name aus  EEProm in buffer kopieren
    seqbuffer_write (http_buffer, "\",\"");                                 // 
    EEProm_Read_String (&http_buffer[seqbufferptr], EE_Msubj_Adr);          // Subject aus EEProm in buffer kopieren
    seqbuffer_write (http_buffer, "\",\"");                                 // 
    EEProm_Read_String (&http_buffer[seqbufferptr], EE_MText_Adr);          // Mail Text aus EEProm in buffer kopieren
    seqbuffer_write (http_buffer, "\"]");                                   // 
    send_tcp_data (strlen(http_buffer), 0);                                 // Daten senden Sequenznummer um die lnge von HtmlHead erhhen
    send_tcp_fin (strlen(http_buffer));                                     // Sendet FIN mit der lnge des letzten Datenpaket
    return;                                                                 //
}                                                                           //
// ***********************************************************************************************************************
*/
