// ***********************************************************************************************************************
// ** File:         httpdata.c                                                                                          **
// ** Title:        HTTP Data                                                                                           **
// ** CPU:          AT89C51ED2                                                                                          **
// ** Created:      23.04.2007                                                                                          **
// ** Revised:      23.04.2007                                                                                          **
// ** Version:      1.0                                                                                                 **
// ** Note:                                                                                                             **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// ***********************************************************************************************************************

// INCLUDES **************************************************************************************************************
#include "httpdata.h"                                                       //
// ***********************************************************************************************************************

// DEFINES ***************************************************************************************************************
                                                                            //
// ***********************************************************************************************************************

// VARIABLES *************************************************************************************************************
                                                                            //
// ***********************************************************************************************************************

PGM_P array[1] PROGMEM = 
{
    HtmlTest/*,
    HtmlKopf1,
    HtmlMain1,
    HtmlIO1,
    HtmlSetup1,
    HtmlMail1,
    CssFormate1,
    JavaAjax,
    Favicon0,
    Favicon1,
    Favicon2*/
};

// Webseite Kopf 1.Teil **************************************************************************************************
PROGMEM unsigned char HtmlTest[] = 
{                                                                           //
    "HTTP/1.0 200\r\n"
    "Content-Type: text/html\r\n"
    "Keep-Alive: close\r\n"
    "\r\n"
    "<HTML>\r\n"
        "<HEAD>\r\n"
            "<meta http-equiv=\"refresh\" content=\"20; \">\r\n"
            "<TITLE>Winkewinke</TITLE>\r\n"
        "</HEAD>\r\n"
        "<BODY>\r\n"
            "ENC28J60 mit AVR<br><br>\r\n"
            "ETH II -> Generiert den Ethernet II Header bestehend aus Destination MAC, Source MAC und Ethernet Type Field<br><br>\r\n"
//            "ARP -> Beantwortet Arp Request und lst IP Adressen in MAC Adressen auf<br><br>\r\n"
//            "ICMP -> Beantwortet ICMP Request (Ping)<br><br>\r\n"
//            "IP -> Generiert den IP Header bestehend aus Version Headerlength, Type of Service, Totallength, Identification, Flags, Fragmentoffset, Time to Live, Protokoll, CRC, SourceIP und Destination IP<br><br>\r\n"
//            "UDP -> Generiert den UDP Header bestehend aus Source Port, Destination Port, UDP Packet length, CRC<br><br>\r\n"
//            "TCP -> Generiert den TCP Header bestehend aus Destination Port, Source Port, Acknowledge Number, Sequence Number, Data Offset, Control Flags, Windowsize, CRC, Urgent Pointer, Options<br><br>\r\n"
//            "HTTP -> SYN, ACK, FIN, PSH, GET main.htm/io.htm/setup.htm<br><br>\r\n"
//            "SMTP -> 220 HELO, 250 MAIL FROM:, 250 RCPT TO:, 354 DATA, 221 Quit<br><br>\r\n"
//            "TP -> Time Protolkoll via UDP port 37<br><br>\r\n"
//            "DNS -> Namensauflsung<br><br>\r\n"
//            "DHCP -> Anfordern von IP-Adresse, Subnet Mask, Gateway Adresse, DNS-Server Adresse\r\n"
        "</BODY>\r\n"
    "</HTML>\r\n"
    "\r\n"
};                                                                          //
/*
const char HtmlKopf1[] PROGMEM = 
//PROGMEM unsigned char HtmlKopf1[] =                                         //
{                                                                           //
    "HTTP/1.0 200 Document follows\r\n"                                     //
    "Server: Franks ENC28J60\r\n"                                           //
    "Content-Type: text/html\r\n"                                           //
    "Keep-Alive: close\r\n"                                                 //
    "\r\n"                                                                  //
    "<html>\r\n"                                                            //
        "<head>\r\n"                                                            //
            "<meta http-equiv=\"content-type\" content=\"text/html;charset=ISO-8859-1\">"//
            "<script src=\"ajax.js\" type=\"text/javascript\"></script>\r\n"        //
            "<link rel=\"stylesheet\" type=\"text/css\" href=\"formate.css\">\r\n"  //
            "<title>ENC28J60 webserver</title>\r\n"                                 //
        "</head>\r\n"                                                           //
    "<body>\r\n"                                                            //
        "<center>\r\n"                                                          //
        "<div class=\"rahmen\">\r\n"                                            //
        "<div class=\"oben\"><div class=\"pad\">Net IO Box</div></div>\r\n"     //
        "<div class=\"links\"><br><br><br><br>\r\n"                             //
        "<a href=\"main.html\" class=\"n\">Home</a><br>\r\n"                    //
        "<a href=\"mail.html\" class=\"n\">E-Mail</a><br>\r\n"                  //
        "<a href=\"io.html\" class=\"n\">Set IO</a><br><br><br><br>\r\n"        //
        "<a href=\"setup.html\" class=\"n\">Setup</a><br><br><br><br>\r\n"      //
        "<center>\r\n"                                                          //
        "<div id=\"date\"></div><br>\r\n"                                       //
        "<div id=\"uhr\"></div><br>\r\n"                                        //
        "<div id=\"port0\"></div><br>\r\n"                                      //
        "<div id=\"port1\"></div><br>\r\n"                                      //
        "</center>\r\n"                                                         //
        "</div>\r\n"                                                            //
};                                                                          //
// ***********************************************************************************************************************

// Webseite die gesendet werden soll main.htm ****************************************************************************
const char HtmlMain1[] PROGMEM = 
//PROGMEM unsigned char HtmlMain1[] =                                         //
{    
        "<div class=\"seitenueber\"><div class=\"pad\">Home :</div></div>\r\n"
        "<div class=\"mainmitte\">\r\n"
        "<div class=\"pad\">\r\n"
            "ETH II -> Generiert den Ethernet II Header bestehend aus Destination MAC, Source MAC und Ethernet Type Field<br><br>\r\n"

            "ARP -> Beantwortet Arp Request und lst IP Adressen in MAC Adressen auf<br><br>\r\n"
            "ICMP -> Beantwortet ICMP Request (Ping)<br><br>\r\n"
            "IP -> Generiert den IP Header bestehend aus Version Headerlength, Type of Service, Totallength, Identification, Flags, Fragmentoffset, Time to Live, Protokoll, CRC, SourceIP und Destination IP<br><br>\r\n"
            "UDP -> Generiert den UDP Header bestehend aus Source Port, Destination Port, UDP Packet length, CRC<br><br>\r\n"
            "TCP -> Generiert den TCP Header bestehend aus Destination Port, Source Port, Acknowledge Number, Sequence Number, Data Offset, Control Flags, Windowsize, CRC, Urgent Pointer, Options<br><br>\r\n"
            "HTTP -> SYN, ACK, FIN, PSH, GET main.htm/io.htm/setup.htm<br><br>\r\n"
            "SMTP -> 220 HELO, 250 MAIL FROM:, 250 RCPT TO:, 354 DATA, 221 Quit<br><br>\r\n"
            "TP -> Time Protolkoll via UDP port 37<br><br>\r\n"
            "DNS -> Namensauflsung<br><br>\r\n"
            "DHCP -> Anfordern von IP-Adresse, Subnet Mask, Gateway Adresse, DNS-Server Adresse\r\n"

        "</div>\r\n"
        "</div>\r\n"
        "</div>\r\n"
        "</center>\r\n"
        "</body>\r\n"
    "</html>\r\n"
};
// ***********************************************************************************************************************

// Webseite die gesendet werden soll setup.htm ***************************************************************************
const char HtmlIO1[] PROGMEM = 
//PROGMEM unsigned char HtmlIO1[] =                                         //
{
    "<div class=\"seitenueber\"><div class=\"pad\">IO Port control :</div></div>\r\n"
    "<div class=\"mainmitte\">\r\n"
    "<div class=\"pad\">\r\n"
    "<div style=\"text-align:right; padding-right:100px;\">\r\n"

    "<form name=\"ioset\">\r\n"
        "<input type=\"checkbox\" name=\"p10\" value=\"1\" onclick=\"abfrage(5);\"> P1.0\r\n"
        "<input type=\"checkbox\" name=\"p11\" value=\"1\" onclick=\"abfrage(5);\"> P1.1\r\n"
        "<input type=\"checkbox\" name=\"p12\" value=\"1\" onclick=\"abfrage(5);\"> P1.2\r\n"
        "<input type=\"checkbox\" name=\"p13\" value=\"1\" onclick=\"abfrage(5);\"> P1.3\r\n"
        "<input type=\"checkbox\" name=\"p14\" value=\"1\" onclick=\"abfrage(5);\"> P1.4\r\n"
        "<input type=\"checkbox\" name=\"p15\" value=\"1\" onclick=\"abfrage(5);\"> P1.5\r\n"
        "<input type=\"checkbox\" name=\"p16\" value=\"1\" onclick=\"abfrage(5);\"> P1.6\r\n"
        "<input type=\"checkbox\" name=\"p17\" value=\"1\" onclick=\"abfrage(5);\"> P1.7<br><br><br><br>\r\n"
        "LCD Output : <input type=\"text\" align=center size=40 MAXLENGTH=40 name=\"lcd\"><br><br><br>\r\n"
        "RS-232 Output : <input type=\"text\" align=center size=40 MAXLENGTH=40 name=\"rs232\"><br><br>\r\n"
        "<button name=\"SaveIO\" type=\"button\" value=\"Setup\" onclick=\"abfrage(5);\">Send Data</button>"
    "</form>\r\n"

    "</div>\r\n"
    "</div>\r\n"
    "</div>\r\n"
    "</div>\r\n"
    "</center>\r\n"
    "</body>\r\n"
    "</html>\r\n"
};
// ***********************************************************************************************************************

// Webseite die gesendet werden soll setup.htm ***************************************************************************
const char HtmlSetup1[] PROGMEM = 
//PROGMEM unsigned char HtmlSetup1[] =                                         //
{
    "<div class=\"seitenueber\"><div class=\"pad\">Setup :</div></div>\r\n"
    "<div class=\"mainmitte\">\r\n"
    "<div class=\"pad\">\r\n"

    "<form name=\"netset\">\r\n"
        "<div style=\"text-align:right; padding-right:240px\">\r\n"
            "IP Address : <input type=\"text\" size=15 maxlength=15 name=\"ip\"><br><br>\r\n"
            "Subnet Mask : <input type=\"text\" size=15 maxlength=15 name=\"sub\"><br><br>\r\n"
            "Gateway : <input type=\"text\" size=15 maxlength=15 name=\"gate\"><br><br>\r\n"
            "DNS-Server : <input type=\"text\" size=15 maxlength=15 name=\"dns\"><br><br>\r\n"
            "Time-Server : <input type=\"text\" size=15 maxlength=40 name=\"sntp\"><br><br>\r\n"
            "MAC-Adresse : <input type=\"text\" size=15 maxlength=17 name=\"mac\" disabled><br><br>\r\n"
            "<button name=\"Save\" type=\"button\" value=\"Setup\" onclick=\"abfrage(3);\">Save Setup</button>"
            "<script type=\"text/javascript\">window.setTimeout(\"abfrage(1)\",1000);</script>\r\n"
        "</div>\r\n"
    "</form>\r\n"

    "</div>\r\n"
    "</div>\r\n"
    "</div>\r\n"
    "</center>\r\n"
    "</body>\r\n"
    "</html>\r\n"
};
// ***********************************************************************************************************************

// Webseite die gesendet werden soll setup.htm ***************************************************************************
const char HtmlMail1[] PROGMEM = 
//PROGMEM unsigned char HtmlMail1[] =                                         //
{
    "<div class=\"seitenueber\"><div class=\"pad\">E-Mail :</div></div>\r\n" 
    "<div class=\"mainmitte\">\r\n"
    "<div class=\"pad\">\r\n"

    "<form accept-charset=\"ISO-8859-1\" name=\"mailset\">\r\n"
        "<div style=\"text-align:right; padding-right:170px\">\r\n"
            "SMTP-Server : <input type=\"text\" size=40 maxlength=40 name=\"smtp\"><br><br>\r\n"
            "Mail From : <input type=\"text\" size=40 maxlength=40 name=\"mfrom\"><br><br>\r\n"
            "Send To : <input type=\"text\" size=40 maxlength=40 name=\"msendto\"><br><br>\r\n"
            "Sender Name : <input type=\"text\" size=40 maxlength=40 name=\"msendn\"><br><br>\r\n"
            "Subject : <input type=\"text\" size=40 maxlength=40 name=\"msubj\"><br><br>\r\n"
            "<textarea name=\"mtext\" cols=\"31\" rows=\"10\"></textarea><br><br>\r\n"
            "<button name=\"SaveM\" type=\"button\" value=\"Setup\" onclick=\"abfrage(4);\">Save Setup</button>"
            "<script type=\"text/javascript\">window.setTimeout(\"abfrage(2)\",1000);</script>\r\n"
        "</div>\r\n"
    "</form>\r\n"

    "</div>\r\n"
    "</div>\r\n"
    "</div>\r\n"
    "</center>\r\n"
    "</body>\r\n"
    "</html>\r\n"
};
// ***********************************************************************************************************************

// Webseite die gesendet werden soll setup.htm ***************************************************************************
const char CssFormate1[] PROGMEM = 
//PROGMEM unsigned char CssFormate1[] =                                         //
{
    "HTTP/1.0 200 Document follows\r\n"
    "Server: Franks ENC28J60\r\n"
    "Content-Type: text/css\r\n"
    "Keep-Alive: close\r\n"
    "\r\n"
    "@charset \"ISO-8859-1\";"
    "body{font-family:Arial,Verdana,Helvetica}\r\n"
    "a.n{width:100px;height:20px;display:block;padding:0px 0px 0px 12px;margin:0px 20px 2px 10px;background-color:#E0E0E9;border:1px solid black;text-decoration:none;font-size:15px;color:#000000;}\r\n"
    "a.n:hover{padding-left:3px;border-left:10px solid darkblue;}\r\n"
    ".rahmen{width:800px;height:600px;border:1px solid black;}\r\n"
    ".oben{width: 800px;height:75px;background:#B0B0FF;color:#FFFF80;font-size:54px;text-align:right;}\r\n"
    ".links{width:130px;height:525px;background:#B0B0FF;border-right:1px solid black;float:left;}\r\n"
    ".seitenueber{width:667px;height:40px;background:#E0E0F9;color:#660033;font-size:19px;float:left;border-top:1px solid black;border-bottom:1px solid black;text-align:left;}\r\n"
    ".mainmitte{width:667px;height:483px;background:#E0E0E9;color:#003399;font-size:15px;float:left;text-align:left;}\r\n"
    ".pad{padding:10px;}\r\n"
};
// ***********************************************************************************************************************

// Webseite die gesendet werden soll setup.htm ***************************************************************************
const char JavaAjax[] PROGMEM = 
//PROGMEM unsigned char JavaAjax[] =                                         //
{
    "HTTP/1.0 200 Document follows\r\n"
    "Server: Franks ENC28J60\r\n"
    "Content-Type: application/x-javascript; charset=ISO-8859-1\r\n"
    "Keep-Alive: close\r\n"
    "\r\n"
    "var http = null;\r\n"
    "window.setInterval(\"time()\",2000);\r\n"
    "if (window.XMLHttpRequest)\r\n"
    "{\r\n"
        "http = new XMLHttpRequest();\r\n"
    "}\r\n"
    "else if (window.ActiveXObject)\r\n"
    "{\r\n"
        "http = new ActiveXObject(\"Microsoft.XMLHTTP\");\r\n"
    "}\r\n"
    "function abfrage(nummer)\r\n"
    "{\r\n"
        "if (http != null){\r\n"
            "var zeit = new Date();\r\n"
            "switch (nummer){\r\n"
                "case 0:\r\n"
                          "http.open(\"GET\",\"dyndata.html?\" + zeit.getTime(),true);\r\n"
                      "break;\r\n"
                "case 1:\r\n"
                          "http.open(\"GET\",\"configip.html?\" + zeit.getTime(),false);\r\n"
                      "break;\r\n"
                      "case 2:\r\n"
                          "http.open(\"GET\",\"configmail.html?\" + zeit.getTime(),false);\r\n"
                      "break;\r\n"
                      "case 3:\r\n"
                          "http.open(\"GET\",\"ipdata.html?\" + zeit.getTime() + \"&ip=\" + document.netset.ip.value + \"&sub=\" + document.netset.sub.value + \"&gate=\" + document.netset.gate.value + \"&dns=\"+ document.netset.dns.value + \"&sntp=\"+ document.netset.sntp.value ,false);\r\n"
                      "break;\r\n"
                      "case 4:\r\n"
                          "http.open(\"GET\",\"maildata.html?\" + zeit.getTime() + \"&smtp=\" + document.mailset.smtp.value + \"&mfrom=\" + document.mailset.mfrom.value + \"&msendto=\" + document.mailset.msendto.value + \"&msendn=\" + document.mailset.msendn.value + \"&msubj=\" + escape(document.mailset.msubj.value) + \"&mtext=\" + escape(document.mailset.mtext.value), false);\r\n"
                      "break;\r\n"
                      "case 5:\r\n"
                          "var ioval = 0;\r\n"
                          "if (document.ioset.p10.checked == true)\r\n"
                          "{\r\n"
                              "ioval = ioval + 1\r\n"
                          "}\r\n"
                          "if (document.ioset.p11.checked == true)\r\n"
                          "{\r\n"
                              "ioval = ioval + 2\r\n"
                          "}\r\n"
                          "if (document.ioset.p12.checked == true)\r\n"
                          "{\r\n"
                              "ioval = ioval + 4\r\n"
                          "}\r\n"
                          "if (document.ioset.p13.checked == true)\r\n"
                          "{\r\n"
                              "ioval = ioval + 8\r\n"
                          "}\r\n"
                          "if (document.ioset.p14.checked == true)\r\n"
                          "{\r\n"
                              "ioval = ioval + 16\r\n"
                          "}\r\n"
                          "if (document.ioset.p15.checked == true)\r\n"
                          "{\r\n"
                              "ioval = ioval + 32\r\n"
                          "}\r\n"
                          "if (document.ioset.p16.checked == true)\r\n"
                          "{\r\n"
                              "ioval = ioval + 64\r\n"
                          "}\r\n"
                          "if (document.ioset.p17.checked == true)\r\n"
                          "{\r\n"
                              "ioval = ioval + 128\r\n"
                          "}\r\n"
                          "http.open(\"GET\",\"iodata.html?\" + zeit.getTime() + \"&port=\" + ioval + \"&rs232=\" + escape(document.ioset.rs232.value) + \"&lcd=\" + escape(document.ioset.lcd.value), false);\r\n"
                      "break;\r\n"
                "}\r\n"
            "http.onreadystatechange = ausgeben;\r\n"
            "http.send(null);\r\n"
        "}\r\n"
    "}\r\n"
    "function time()\r\n"
    "{\r\n"
        "abfrage(0);\r\n"
    "}\r\n"
    "function ausgeben()\r\n"
    "{\r\n"
        "if (http.readyState == 4)\r\n"
        "{\r\n"
            "var json_array = http.responseText;\r\n"
            "var a = eval(\"(\" + json_array + \")\");\r\n"
            "var fall = parseInt(a[0]);\r\n"
            "switch (fall){\r\n"
                "case 0:\r\n"
                    "document.getElementById(\"uhr\").innerHTML = a[1];\r\n"
                    "document.getElementById(\"port0\").innerHTML = a[2];\r\n"
                    "document.getElementById(\"port1\").innerHTML = a[3];\r\n"
                    "document.getElementById(\"date\").innerHTML = a[4];\r\n"
                    "if(document.ioset)\r\n"
                    "{\r\n"
                        "if( a[3] & 1 )"
                        "{\r\n"
                            "document.ioset.p10.checked = true\r\n"
                        "}\r\n"
                        "if( a[3] & 2 )"
                        "{\r\n"
                            "document.ioset.p11.checked = true\r\n"
                        "}\r\n"
                        "if( a[3] & 4 )"
                        "{\r\n"
                            "document.ioset.p12.checked = true\r\n"
                        "}\r\n"
                        "if( a[3] & 8 )"
                        "{\r\n"
                            "document.ioset.p13.checked = true\r\n"
                        "}\r\n"
                        "if( a[3] & 16 )"
                        "{\r\n"
                            "document.ioset.p14.checked = true\r\n"
                        "}\r\n"
                        "if( a[3] & 32 )"
                        "{\r\n"
                            "document.ioset.p15.checked = true\r\n"
                        "}\r\n"
                        "if( a[3] & 64 )"
                        "{\r\n"
                            "document.ioset.p16.checked = true\r\n"
                        "}\r\n"
                        "if( a[3] & 128 )"
                        "{\r\n"
                            "document.ioset.p17.checked = true\r\n"
                        "}\r\n"
                    "}\r\n"
                "break;\r\n"
                "case 1:\r\n"
                    "if(document.netset)\r\n"
                    "{\r\n"
                        "document.netset.ip.value = a[1];\r\n"
                        "document.netset.sub.value = a[2];\r\n"
                        "document.netset.gate.value = a[3];\r\n"
                        "document.netset.dns.value = a[4];\r\n"
                        "document.netset.sntp.value = a[5];\r\n"
                        "document.netset.mac.value = a[6];\r\n"
                    "}\r\n"
                "break;\r\n"
                "case 2:\r\n"
                    "if(document.mailset)\r\n"
                    "{\r\n"
                        "document.mailset.smtp.value = unescape(a[1]);\r\n"
                        "document.mailset.mfrom.value = unescape(a[2]);\r\n"
                        "document.mailset.msendto.value = unescape(a[3]);\r\n"
                        "document.mailset.msendn.value = unescape(a[4]);\r\n"
                        "document.mailset.msubj.value = unescape(a[5]);\r\n"
                        "document.mailset.mtext.value = unescape(a[6]);\r\n"
                    "}\r\n"
                "break;\r\n"
            "}\r\n"
        "}\r\n"
    "}\r\n"
};
// ***********************************************************************************************************************

// Webseite die gesendet werden soll setup.htm ***************************************************************************
const char Favicon0[] PROGMEM = 
//PROGMEM unsigned char Favicon0[] =                                         //
{
    "HTTP/1.0 404 Not Found\r\n"
    "Server: Franks ENC28J60\r\n"                                           //
    "Content-Type: text/html\r\n"                                           //
    "Keep-Alive: close\r\n"                                                 //
    "\r\n"
};
// ***********************************************************************************************************************

// Webseite die gesendet werden soll setup.htm ***************************************************************************
const char Favicon1[] PROGMEM = 
//PROGMEM unsigned char Favicon1[] =                                         //
{
    "HTTP/1.0 200 Document follows\r\n"
    "Server: Franks ENC28J60\r\n"
    "Content-Type: application/octet-stream\r\n"
    "Keep-Alive: close\r\n"
    "\r\n"
};
// ***********************************************************************************************************************

// Webseite die gesendet werden soll setup.htm ***************************************************************************
const char Favicon2[] PROGMEM = 
//PROGMEM unsigned char Favicon2[] =                                         //
{
    0x00,0x00,0x01,0x00,0x01,0x00,0x10,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x68,0x05,
    0x00,0x00,0x16,0x00,0x00,0x00,0x28,0x00,0x00,0x00,0x10,0x00,0x00,0x00,0x20,0x00,
    0x00,0x00,0x01,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x40,0x01,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0xFF,0xFF,0xFF,0x00,0x85,0x85,0x85,0x00,0x5F,0x5F,0x5F,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x0C,0x00,0x01,0x00,0x01,0x00,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x02,0x0C,0x00,0x00,0x01,0x00,0x01,0x00,0x0C,0x02,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x0C,0x00,0x01,0x01,0x01,0x01,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x02,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x02,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x0C,0x00,0x00,0x01,0x01,0x01,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x02,0x0C,0x00,0x01,0x00,0x00,0x00,0x00,0x0C,0x02,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x0C,0x00,0x00,0x01,0x01,0x01,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x02,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x02,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x0C,0x00,0x01,0x01,0x01,0x00,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x02,0x0C,0x00,0x00,0x01,0x00,0x01,0x00,0x0C,0x02,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x0C,0x00,0x01,0x01,0x01,0x00,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x02,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x02,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x03,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF0,0x0F,
    0x00,0x00,0xE0,0x07,0x00,0x00,0xF0,0x0F,0x00,0x00,0xE0,0x07,0x00,0x00,0xF0,0x0F,
    0x00,0x00,0xE0,0x07,0x00,0x00,0xF0,0x0F,0x00,0x00,0xE0,0x07,0x00,0x00,0xF0,0x0F,
    0x00,0x00,0xE0,0x07,0x00,0x00,0xF0,0x0F,0x00,0x00,0xE0,0x07,0x00,0x00,0xF0,0x0F,
    0x00,0x00,0xE0,0x07,0x00,0x00,0xF0,0x0F,0x00,0x00,0xF0,0x0F,0x00,0x00,0x00
};
*/
// ***********************************************************************************************************************
