// ***********************************************************************************************************************
// ** File:         icmp.h                                                                                              **
// ** Title:        Routine for ICMP Protocol                                                                           **
// ** CPU:          ATMega644                                                                                           **
// ** Created:      28.02.2008                                                                                          **
// ** Revised:      28.02.2008                                                                                          **
// ** Version:      1.0                                                                                                 **
// ** Note:                                                                                                             **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// ***********************************************************************************************************************

// COMPILER INFORMATION **************************************************************************************************
#ifndef ICMP_H                                                              //
#define ICMP_H                                                              //
// ***********************************************************************************************************************

// INCLUDES **************************************************************************************************************
#include "crc.h"                                                            //
#include "ethernet.h"                                                       //
//#include "debug.h"                                                          //
// ***********************************************************************************************************************

// DEFINES ***************************************************************************************************************
                                                                            //
// ***********************************************************************************************************************

// VARIABLES *************************************************************************************************************
                                                                            //
// ***********************************************************************************************************************

// FUNCTIONS *************************************************************************************************************
void icmp( unsigned int packet_lenght );                                    //
// ***********************************************************************************************************************

// ICMP Struct ***********************************************************************************************************
struct ICMP_header                                                          //
{                                                                           //
    unsigned char ICMP_type;                                                // 1 Byte
    unsigned char ICMP_code;                                                // 1 Byte
    unsigned char ICMP_checksumByteOne;                                     // 1 Byte
    unsigned char ICMP_checksumByteTwo;                                     // 1 Byte = 4 Bytes
};                                                                          //
// ***********************************************************************************************************************
#endif
