// ***********************************************************************************************************************
// ** File:         ip.h                                                                                                **
// ** Title:        Routine for IP Protocol                                                                             **
// ** CPU:          ATMega644                                                                                           **
// ** Created:      28.02.2008                                                                                          **
// ** Revised:      28.02.2008                                                                                          **
// ** Version:      1.0                                                                                                 **
// ** Note:                                                                                                             **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// ***********************************************************************************************************************

// COMPILER INFORMATION **************************************************************************************************
#ifndef IP_H                                                                //
#define IP_H                                                                //
// ***********************************************************************************************************************

// INCLUDES **************************************************************************************************************
#include "arp.h"                                                            //
#include "icmp.h"                                                           //
#include "crc.h"                                                            //
#include "ethernet.h"                                                       //
#include "udp.h"                                                            //
#include "tcp.h"                                                            //
//#include "debug.h"                                                          //
// ***********************************************************************************************************************

// DEFINES ***************************************************************************************************************
#define IP_HEADER_LENGTH            20                                      // IP Header ist 20 Bytes lang
#define IP_PSEUDOHEADER_LENGHT      12                                      //
// ***********************************************************************************************************************

// VARIABLES *************************************************************************************************************
                                                                            //
// ***********************************************************************************************************************

// FUNCTIONS *************************************************************************************************************
void MakeIPheader(unsigned long SourceIP,unsigned char Protocoll,unsigned int Datalenght);//
void MakePseudoHeader (unsigned long SourceIP,unsigned char Protocoll,unsigned int Datalenght);
void ip( unsigned int packet_lenght );                                      //
// ***********************************************************************************************************************

// ip Struct *************************************************************************************************************
struct IP_header                                                            //
{                                                                           //
    unsigned char IP_Version_Headerlen;                                     // 1 Byte
    unsigned char IP_TOS;                                                   // 1 Byte
    unsigned int IP_Totallenght;                                            // 2 Byte
    unsigned int IP_Identification;                                         // 2 Byte
    unsigned char IP_Flags;                                                 // 1 Byte
    unsigned char IP_Fragmentoffset;                                        // 1 Byte
    unsigned char IP_TTL;                                                   // 1 Byte
    unsigned char IP_Protocol;                                              // 1 Byte
    unsigned int IP_Headerchecksum;                                         // 2 Byte
    unsigned long IP_SourceIP;                                              // 4 Byte
    unsigned long IP_DestinationIP;                                         // 4 Byte = 20 Bytes
};                                                                          //
// ***********************************************************************************************************************

// Pseudo Header Struct **************************************************************************************************
struct IP_Pseudoheader                                                      //
{                                                                           //
    volatile unsigned long IP_SourceIP;                                     // Quell IP
    volatile unsigned long IP_DestinationIP;                                // Ziel IP
    volatile unsigned char IP_ZERO;                                         // muss 0 sein
    volatile unsigned char IP_Protokoll;                                    // bei TCP immer 6
    volatile unsigned int IP_lenght;                                        // lnge des Nutzdaten Segmentes ( TCP_Segment )
};                                                                          //
// ***********************************************************************************************************************

#endif
