// ***********************************************************************************************************************
// ** File:         main.c                                                                                              **
// ** Title:                                                                                                            **
// ** CPU:          ATMega644                                                                                           **
// ** Created:      27.02.2008                                                                                          **
// ** Revised:      27.02.2008                                                                                          **
// ** Version:      1.0                                                                                                 **
// ** Note:                                                                                                             **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// ***********************************************************************************************************************

// COMPILER INFORMATION **************************************************************************************************
                                                                            //
// ***********************************************************************************************************************

// INCLUDES **************************************************************************************************************
#include <stdint.h>                                                         // ISO C99 Integer types
#include <avr/io.h>                                                         // ATTINY I/O's
#include <util/delay.h>                                                     // delay Lib.
#include <avr/pgmspace.h>
#include "global.h"                                                         //
#include "spi.h"                                                            //
#include "ethernet.h"                                                       //
#include "enc28j60.h"                                                       //
#include "timer.h"                                                          //
#include "dhcp.h"
#include "dns.h"
#include "sntp.h"   
#include "udp.h"
#include <stdlib.h>                                                         //

// ***********************************************************************************************************************

// STRUCTURES ************************************************************************************************************
                                                                            //
// ***********************************************************************************************************************

// DEFINES ***************************************************************************************************************
                                                                            //

// ***********************************************************************************************************************

// VARIABLES *************************************************************************************************************
                                                                            //
// ***********************************************************************************************************************

// FUNCTION **************************************************************************************************************
void net_init (void)                                                        //
{                                                                           //
    unsigned char i = 0;                                                    //
    MyMac [0] = 0x00;                                                       // MAC Adresse fr ENC
    MyMac [1] = 0x01;                                                       // 00:01:4a:2f:f9:f8
    MyMac [2] = 0x4a;                                                       // 
    MyMac [3] = 0x2f;                                                       // 
    MyMac [4] = 0xf9;                                                       // 
    MyMac [5] = 0xf8;                                                       // 
    MyIP.LONG = 0x7b00a8c0;                                                 // IP Adresse fr ENC  192.168.0.123
    Netmask.LONG = 0x00ffffff;                                              // Subnet Mask fr ENC 255.255.255.0
    Gateway.LONG = 0x0100a8c0;                                              // Gateway IP adresse 192.168.0.1
    DNSserver.LONG = 0x0100a8c0;                                            // DNS Server Adresse 192.168.0.1
    spi_init();                                                             // 
    enc28j60Init();                                                         // 
    for (i=0;i<6;++i)                                                       // 
    {                                                                       // 
        enc28j60PhyWrite (0x14, 0x3992);                                    // Beide LEDs aus
        _delay_ms (200);                                                    // 
        enc28j60PhyWrite (0x14, 0x3882);                                    // Beide LEDs an
        _delay_ms (200);                                                    // 
    }                                                                       // 
    enc28j60PhyWrite (0x14, 0x3422);                                        // LED Grn auf Link, LED Rot auf RX activity
}                                                                           // 
// ***********************************************************************************************************************

// FUNCTION **************************************************************************************************************
int main (void)                                                             //
{                                                                           //
    unsigned char delta_minutes = 0;
    net_init();                                                             //
    DDRD = (1 << DDB0);                                                     //
    timer_1_start();                                                        //
    LED = 1;                                                                //
    DHCP_GetConfig();
    timesync();                                                             // Timesync starten
    while(1)                                                                //
    {                                                                       //
        ethernet();                                                         // Prfe ob ein Paket angekommen ist
        if (delta_minutes != minutes)
        {
            timesync();                                                     // Timesync starten
            delta_minutes = minutes;
        }
    }                                                                       //
}                                                                           //
// ***********************************************************************************************************************
