// ***********************************************************************************************************************
// ** File:         sntp.h                                                                                              **
// ** Title:        Routine for Simple Network Time Protocol                                                            **
// ** CPU:          AT89C51ED2                                                                                          **
// ** Created:      23.04.2007                                                                                          **
// ** Revised:      23.04.2007                                                                                          **
// ** Version:      1.0                                                                                                 **
// ** Note:                                                                                                             **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// ***********************************************************************************************************************

// COMPILER INFORMATION **************************************************************************************************
#ifndef SNTP_H                                                              //
#define SNTP_H                                                              //
// ***********************************************************************************************************************

// INCLUDES **************************************************************************************************************
#include "enc28j60.h"                                                       //
#include "ethernet.h"                                                       //
#include "ip.h"                                                             //
#include "udp.h"                                                            //
#include "timer.h"                                                          //
#include "dns.h"
#include "global.h"
//#include "debug.h"                                                          //
// ***********************************************************************************************************************

// DEFINES ***************************************************************************************************************
#define NTP_ANSWER              0                                           //
#define NO_NTP_ANSWER           !NTP_ANSWER                                 //
// ***********************************************************************************************************************

// VARIABLES *************************************************************************************************************
extern volatile unsigned char NTP_Flag;                                     //
// ***********************************************************************************************************************

// FUNCTIONS *************************************************************************************************************
void SNTP(void);                                                            //
unsigned char timesync(void);                                               //
// ***********************************************************************************************************************

// Time Answer union ****************************************************************************************************
union DATE                                                                  //
{                                                                           //
    unsigned char DateByte[4];                                              //
    unsigned long Date;                                                     //
};                                                                          //
// ***********************************************************************************************************************
#endif
