// ***********************************************************************************************************************
// ** File:         spi.c                                                                                               **
// ** Title:                                                                                                            **
// ** CPU:          ATMega644                                                                                           **
// ** Created:      27.02.2008                                                                                          **
// ** Revised:      27.02.2008                                                                                          **
// ** Version:      1.0                                                                                                 **
// ** Note:                                                                                                             **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// ***********************************************************************************************************************

// INCLUDES **************************************************************************************************************
#include "spi.h"                                                            // 
#include "global.h"                                                         //
#include <avr/io.h>                                                         // ATTINY I/O's
// ***********************************************************************************************************************

// STRUCTURES ************************************************************************************************************
                                                                            //
// ***********************************************************************************************************************

// DEFINES ***************************************************************************************************************
                                                                            //
// ***********************************************************************************************************************

// VARIABLES *************************************************************************************************************
                                                                            //
// ***********************************************************************************************************************

// SPI Initialize ********************************************************************************************************
void spi_init (void)                                                        // 
{                                                                           // 
    DDRB = (1 << DDB4)|(1 << DDB5)|(1 << DDB7);                             // ENC CS, MOSI und SCK auf Ausgang
    SPCR = (1 << SPE)|(1 << MSTR);                                          // Enable SPI, Master
    SPSR = (1 << SPI2X);                                                    // set clock rate fck/2
    ENC28J60_CS = 1;                                                        // ENC Chip Select auf High
}                                                                           // 
// ***********************************************************************************************************************

// SPI Out Function ******************************************************************************************************
void spi_out (unsigned char cData)                                          // 
{                                                                           // 
    SPDR = cData;                                                           // Start transmission
    while(!(SPSR & (1<<SPIF)));                                             // Wait for transmission complete
}                                                                           // 
// ***********************************************************************************************************************

// SPI In Function *******************************************************************************************************
unsigned char spi_in (void)                                                 // 
{                                                                           // 
    SPDR = 0x00;                                                            // Start transmission
    while(!(SPSR & (1<<SPIF)));                                             // Wait for transmission complete
    return SPDR;                                                            // Return SPI Data
}                                                                           // 
// ***********************************************************************************************************************
