// ***********************************************************************************************************************
// ** File:         timer.h                                                                                             **
// ** Title:        Timer Routine for Webserver                                                                         **
// ** CPU:          AT89C51ED2                                                                                          **
// ** Created:      23.04.2007                                                                                          **
// ** Revised:      23.04.2007                                                                                          **
// ** Version:      1.0                                                                                                 **
// ** Note:                                                                                                             **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// ***********************************************************************************************************************

// COMPILER INFORMATION **************************************************************************************************
#ifndef TIMER_H                                                             //
#define TIMER_H                                                             //
// ***********************************************************************************************************************

// INCLUDES **************************************************************************************************************
#include <avr/interrupt.h>                                                  //
#include <avr/pgmspace.h>
#include "global.h"
//#include "debug.h"                                                          //
// ***********************************************************************************************************************

// DEFINES ***************************************************************************************************************
#define DaysPerWeek             7                                           //
#define TimeZone                3600                                        //
#define TimeOut                 10                                          //
#define SZ_SET                  0                                           // Sommerzeit Flag
#define SZ_NOT_SET              !SZ_SET                                     // Sommerzeit Flag
// ***********************************************************************************************************************

// VARIABLES *************************************************************************************************************
extern unsigned char timermsec;                                             // Milisekundenspeicher
extern unsigned char seconds;                                               // Sekundenspeicher
extern unsigned char minutes;                                               // Minutenspeicher
extern unsigned char hours;                                                 // Stundenspeicher
extern unsigned char day;                                                   // Tagesspeicher
extern unsigned char wday;                                                  // Wochentagspeicher Montag = 0
extern unsigned char month;                                                 // Monatsspeicher
extern unsigned int year;                                                   // Jahresspeicher
extern volatile unsigned char deltasec;                                     // Delta Sekunden fr Timeouts 
extern unsigned char SZ_Flag;                                               //
// ***********************************************************************************************************************

// CONSTANTS *************************************************************************************************************
extern PROGMEM unsigned char Month_to_days[12];                             //
extern char *Month_to_string[12] PROGMEM;                                   //
extern char *Day_to_wdays[7] PROGMEM;                                       //
// ***********************************************************************************************************************

// FUNCTIONS *************************************************************************************************************
void timer_1_start(void);                                                   //
ISR( TIMER1_OVF_vect );                                                     //
// ***********************************************************************************************************************
#endif
