// ***********************************************************************************************************************
// ** File:         udp.h                                                                                               **
// ** Title:        Routine for UDP Protocol                                                                            **
// ** CPU:          AT89C51ED2                                                                                          **
// ** Created:      23.04.2007                                                                                          **
// ** Revised:      23.04.2007                                                                                          **
// ** Version:      1.0                                                                                                 **
// ** Note:                                                                                                             **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// **                                                                                                                   **
// ***********************************************************************************************************************

// COMPILER INFORMATION **************************************************************************************************
#ifndef UDP_H                                                               //
#define UDP_H                                                               //
// ***********************************************************************************************************************

// INCLUDES **************************************************************************************************************
#include "ethernet.h"                                                       //
//#include "dns.h"                                                            //
//#include "sntp.h"                                                           //
#include "dhcp.h"                                                           //
//#include "debug.h"                                                          //
//#include "max186.h"                                                         //
//#include <string.h>                                                         //
//#include <stdio.h>                                                          //
// ***********************************************************************************************************************

// DEFINES ***************************************************************************************************************
#define UDP_HEADER_LENGHT           8                                       //
// ***********************************************************************************************************************

// VARIABLES *************************************************************************************************************
extern unsigned char DestMACAddress[6];                                     // Buffer fr die Ziel MAC Adresse
// ***********************************************************************************************************************

// FUNCTIONS *************************************************************************************************************
void udp_send( unsigned char *DestMACAddress, unsigned long DestIPAddress, unsigned long SourcePort, unsigned long DestPort,
    unsigned int datalen);
void udp(void);                                                             //
// ***********************************************************************************************************************

// UDP Struct ************************************************************************************************************
struct UDP_header                                                           //
{                                                                           //
    unsigned int UDP_SourcePort;                                            // 2 Byte
    unsigned int UDP_DestinationPort;                                       // 2 Byte
    unsigned int UDP_Datalenght;                                            // 2 Byte
    unsigned int UDP_Checksum;                                              // 2 Byte
};                                                                          //
// ***********************************************************************************************************************
#endif
